Imports ProductList
Imports System.Data

Partial Class DataTableExample
    Inherits System.Web.UI.Page

    Protected Sub btnSelectAllToDataTable_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSelectAllToDataTable.Click

        ' Declare SelectAll as a new instance of the HeadCategories class without any parameters
        Dim SelectAll As New HeadCategories()

        ' Set the datasource for our Repeater control to the DataTable that are returned from the
        ' SelectAllToDataTable function in the HeadCategories class (no parameters)
        SelectAllRepeater.DataSource = SelectAll.SelectAllToDataTable()

        ' Bind the datasource to the SelectAllRepeater 
        SelectAllRepeater.DataBind()

    End Sub

    Protected Sub btnAddManyRows_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnAddManyRows.Click

        ' The Using block is used to automatically call dispose for the DataTable when it is not used any more
        Using ManyRowsDataTable As New DataTable

            ' Declare variables for DataColumn and DataRow objects.
            Dim column As DataColumn
            Dim row As DataRow

            ' Create and add the first column
            column = New DataColumn("LinkName")
            ManyRowsDataTable.Columns.Add(column)

            ' Create and add the second column
            column = New DataColumn("Description")
            ManyRowsDataTable.Columns.Add(column)

            ' Declare variables for a tablerow, rownumber and total number of table rows (ignoring the TableHeaderRow) 
            Dim CurrentRow As Int32
            Dim RowNumber As Int32 = 1
            Dim TotalOfTableRows As Int32 = ManyRowsTable.Rows.Count - 1

            ' A For-loop to loop through each table row in our ASP.NET table and to add rows in our ManyRowsDataTable
            For CurrentRow = 1 To TotalOfTableRows

                ' Find the textboxes in each table row
                Dim LinkNameText As TextBox = DirectCast(ManyRowsTable.FindControl("txtLinkName" & RowNumber), TextBox)
                Dim DescriptionText As TextBox = DirectCast(ManyRowsTable.FindControl("txtDescription" & RowNumber), TextBox)

                ' Add a row in the ManyRowsDataTable if the values in both of the textboxes not is blank
                If Not LinkNameText.Text = String.Empty And Not DescriptionText.Text = String.Empty Then
                    ' Add one row with values in the two columns LinkName and Description
                    row = ManyRowsDataTable.NewRow()
                    row("LinkName") = LinkNameText.Text
                    row("Description") = DescriptionText.Text
                    ManyRowsDataTable.Rows.Add(row)

                    ' Add 1 to the rownumber
                    RowNumber = RowNumber + 1

                End If

            Next CurrentRow

            ' Declare InsertManyRows as a new instance of the HeadCategories class
            Dim InsertManyRows As New HeadCategories()

            ' Call the method InsertManyRows in the HeadCategories class and add the DataTable as a parameter
            InsertManyRows.InsertManyRows(ManyRowsDataTable)

        End Using

        ' Delete the session that stores the number of added rows
        Session.Remove("AddedRows")

        ' Reload the page.
        Response.Redirect("DataTable.aspx")

    End Sub

    Protected Sub btnAddRowsToTable_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnAddRowsToTable.Click

        ' Declare variables used for looping and to set the ID for textboxes (NumberOfRows)
        Dim StartNumber As Int32
        Dim EndNumber As Int32 = Convert.ToInt32(txtAddRows.Text)
        Dim NumberOfRows As Int32 = ManyRowsTable.Rows.Count - 1

        ' Declare variables for a table row, a table cell and a textbox
        Dim tRow As TableRow
        Dim tCell As TableCell
        Dim tTextBox As TextBox

        ' A For-loop to add rows to our ASP.NET table
        For StartNumber = 1 To EndNumber

            ' Add the first table row
            tRow = New TableRow()
            ManyRowsTable.Rows.Add(tRow)

            ' Add the first table cell
            tCell = New TableCell()
            tRow.Cells.Add(tCell)

            ' Add the first textbox
            tTextBox = New TextBox()
            tTextBox.ID = "txtLinkName" & (NumberOfRows + StartNumber)
            tTextBox.Width = Unit.Percentage(95)
            tCell.Controls.Add(tTextBox)

            ' Add the second table cell
            tCell = New TableCell()
            tRow.Cells.Add(tCell)

            ' Add the second textbox
            tTextBox = New TextBox()
            tTextBox.ID = "txtDescription" & (NumberOfRows + StartNumber)
            tTextBox.Width = Unit.Percentage(95)
            tCell.Controls.Add(tTextBox)

        Next StartNumber

        ' Add the number of added rows to a session variable so that we are able to retain the added rows 
        ' and the values (ViewState) in added textboxes, see the Page_Init event.
        Session("AddedRows") = EndNumber + Convert.ToInt32(Session("AddedRows"))

    End Sub

    Protected Sub Page_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Init

        ' Declare variables used for looping and to set the ID for textboxes (NumberOfRows)
        Dim StartNumber As Int32
        Dim AddedRows As Int32 = 0
        Dim NumberOfRows As Int32 = ManyRowsTable.Rows.Count - 1

        ' Set the number of added rows.
        If Not Session("AddedRows") = Nothing Then
            AddedRows = Convert.ToInt32(Session("AddedRows"))
        End If

        ' Declare variables for a table row, a table cell and a textbox
        Dim tRow As TableRow
        Dim tCell As TableCell
        Dim tTextBox As TextBox

        ' A For-loop to add rows to our ASP.NET table
        For StartNumber = 1 To AddedRows

            ' Add the first table row
            tRow = New TableRow()
            ManyRowsTable.Rows.Add(tRow)

            ' Add the first table cell
            tCell = New TableCell()
            tRow.Cells.Add(tCell)

            ' Add the first textbox
            tTextBox = New TextBox()
            tTextBox.ID = "txtLinkName" & (NumberOfRows + StartNumber)
            tTextBox.Width = Unit.Percentage(95)
            tCell.Controls.Add(tTextBox)

            ' Add the second table cell
            tCell = New TableCell()
            tRow.Cells.Add(tCell)

            ' Add the second textbox
            tTextBox = New TextBox()
            tTextBox.ID = "txtDescription" & (NumberOfRows + StartNumber)
            tTextBox.Width = Unit.Percentage(95)
            tCell.Controls.Add(tTextBox)

        Next StartNumber

    End Sub

End Class
